"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var mapDataToHash = function mapDataToHash(data) {
  return data.reduce(function (item, acc) {
    acc[item._id.toString()] = item; // eslint-disable-line no-underscore-dangle
    return acc;
  }, {});
};

var loader = exports.loader = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(model, ids) {
    var data, hash;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return model.find({ _id: { $in: ids } });

          case 2:
            data = _context.sent;
            hash = mapDataToHash(data);
            return _context.abrupt("return", ids.map(function (id) {
              if (hash[id.toString()]) {
                return hash[id.toString()];
              }
              return null;
            }));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function loader(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = loader;